
<style>
    .custom-table {
        border: 1px solid #003366;
    }
    table tr.section-header {
        background-color: #697171 !important;
        font-weight: bold;
        color: white;  /* 添加文字顏色確保可見 */
    }
</style>
<h2><{$smarty.const._MD_KWCLUB_INDEX_TEACHER}></h2>
<{if $smarty.session.isclubAdmin || $smarty.session.isclubUser}>
    <div class="text-right" style="font-size:0.9em;margin: 2px auto 30px;color:rgb(97, 29, 63);">
        <i class="fa fa-lightbulb" aria-hidden="true"></i>
        <{if $smarty.session.isclubUser|default:false}>
            <{$smarty.const._MD_KWCLUB_TEACHER_IMG_DESC}>
            <{$smarty.const._MD_KWCLUB_TEACHER_DESC}>
        <{/if}>
        <{if $smarty.session.isclubAdmin|default:false}>
            <{$smarty.const._MD_KWCLUB_CLICK_BIO_TO_EDIT_DESC}>
        <{/if}>
    </div>
<{/if}>
<div class="vtable">
<{foreach from=$teachers key=uid item=tea}>
    <table class="table table-bordered custom-table align-middle">
        <tbody>
            <!-- 姓名 -->
            <tr> 
                <th scope="row" class="text-center" style="width: 20%;">姓名</th>
                <td><span style="width: 30%;color:#337ab7"> <{$tea.teacher_title}></span></td>
                <td rowspan="2" class="text-center">
                    <img src="../../uploads/avatars/blank.gif" 
                        alt="教師照片" 
                        style="width: 120px; object-fit: cover;" />
                        <{if $smarty.session.isclubAdmin || $smarty.session.isclubUser}>
                        <div class="text-right" style="font-size:0.9em;margin: 2px auto 30px;color:rgb(97, 29, 63);">
                            <i class="fa fa-lightbulb" aria-hidden="true"></i>
                            <{if $smarty.session.isclubUser|default:false}>
                                <{$smarty.const._MD_KWCLUB_TEACHER_IMG_DESC}>
                            <{/if}>
                        </div>
                    <{/if}>

                        
                </td>
            </tr>
            <tr>   
                <th scope="row" class="text-center " style="width: 20%;">性別</th>
                <td><span style="width: 30%;color:#337ab7">女</span></td>
            </tr>
            <!-- 教師簡介 -->
            <tr >
                <th scope="row" class="text-center" colspan="3" style="background-color: #cccfcf;">教師簡介</th>
            </tr>
            <tr >
                <td colspan="3">
                    <pre style="white-space: pre-wrap; background: transparent; border: none; padding: 2px;" id="bio_<{$uid|default:''}>" title="<{$smarty.const._MD_KWCLUB_CLICK_TO_EDIT}>"><{$tea.teacher_desc}><{$uid.bio}></pre>
                </td>
            </tr>
            <!-- 相關資料 -->
            <tr class="text-center section-header">
                <th scope="row" class="text-center section-header" colspan="3" style="background-color: #cccfcf;">相關檔案</th>
            </tr>
            <tr>
                <td colspan="3">
                    <{if $smarty.session.isclubAdmin || $smarty.session.isclubUser}>
                    <form action="" method="post" id="uploadForm_<{$tea.teacher_id}>" enctype="multipart/form-data" class="d-flex align-items-center" novalidate>
                        <input type="hidden" name="teacher_id" id="teacher_id" value="<{$tea.teacher_id}>">
                        <input type="hidden" name="op" id="op" value="upload">
                        <!-- 文件上傳輸入框 -->
                        <div class="me-3">
                            <label for="files_<{$tea.teacher_id}>" class="form-label mb-0 me-2">上傳文件</label>
                            <input 
                                type="file" 
                                name="files[]" 
                                id="files_<{$tea.teacher_id}>" 
                                class="form-control form-control-sm" 
                                accept="image/*,video/*,.pdf" 
                                multiple 
                                onchange="handleFileUpload(this)">
                        </div>
                    </form>
                    
                    
                    <{/if}>
                    <{foreach from=$tea.files key=i item=file}>
                    <div class="row" id="list_file">
                        <{if $smarty.session.isclubAdmin || $smarty.session.isclubUser}>
                        <div class="col col-md-1" ><img src="assets/images/del.png" class='image' id="del_<{$file.files_sn}>" data-value="<{$file.files_sn}>" title="刪除<{$file.file_name}> " alt="刪除<{$file.file_name}>"></div>
                        <{/if}>
                        <div class="col"><a href="<{$web_url|default:''}><{$file.sub_dir}>" target="_blank" title="<{$file.file_name}>" alt="<{$file.file_name}>"><{$file.file_name}></a></div>
                    </div>
                <{/foreach}>
                </td>
            </tr>
            <!-- 開課紀錄 -->
            <tr>
                <th scope="row" class="text-center section-header" colspan="3" style="background-color: #cccfcf;">開課紀錄</th>
            </tr>
            <tr>
                <td colspan="3">
                <{foreach from=$tea_class.$uid key=class_id item=class}>
                    <div style="font-size: 0.9em; list-style-position: inside;"><{$class.club_year}> <a href="index.php?class_id=<{$class_id|default:''}>"><{$class.class_title}></a></div>
                <{/foreach}>
                </td>
            </tr>
        </tbody>
    </table>
<{/foreach}>
</div>

<script src="https://cdn.jsdelivr.net/npm/sweetalert2@11"></script>
<script type="text/javascript">
$(document).ready(function() {

    $('.image').click(function () {
        let file_id = $(this).data("value");
        //alert("click!"+file_id);
        $.get("ajax.php", {op:"delete", file_id: file_id })
        .then(function(res){
            data = JSON.parse(res); //parser JSON物件
            if(data.msg=="success"){
                swal.fire("成功","刪除成功!","success");
                setTimeout(function() {
                    window.parent.location.reload();
                }, 1000);
            }
            else
                swal.fire("失敗",data.msg,"error");
        }).fail( function(hxr, error) {
            console.log(error);
            swal.fire("錯誤","網路連線錯誤!!","error");
        });

       /* $.ajax({
            url: 'ajax.php?op=delete&file_id='+file_id, // 伺服器端處理上傳的URL
            type: 'GET',
            dataType: "json",
            success: function (data) {
                console.log(data);
                if(data.msg=='success')
                    swal("成功","成功","success");
                else
                    swal("失敗",data.msg,"error");
            }
        });//end ajax*/
    });


    $('input[type="file"]').on('change', function () {
        const input = this;
        if (!checkfile(input)) {
            return; // 如果文件验证失败，直接退出
        }
        let files = $(this).prop('files');
        let form = $(this).closest('form');
        const formData = new FormData(form[0]);

        $.ajax({
            url: 'ajax.php', // 伺服器端處理上傳的URL
            type: 'POST',
            data: formData,
            dataType: "json",
            contentType: false, // 設定contentType為false，讓瀏覽器自動設定正確的內容類型
            processData: false, // 設定processData為false，讓瀏覽器不要對資料進行序列化或轉換
            success: function (data) {
                if(data.msg=="success"){
                    swal.fire("成功","上傳成功!!" ,"success");
                    setTimeout(function() {
                        window.parent.location.reload();
                    }, 1000);
                }
                else if(data.msg == "error")
                    swal.fire("失敗","上傳失敗", "error");
                else
                    swal.fire("錯誤", msg, "error");
            },
            error: function (xhr, status, error) {
                console.log(xhr, status, error);
                swal.fire("失敗","網路錯誤連線失敗", "error");
            }
        });//end ajax
    });//end change

});//end document


function checkfile(input) {
    const validExts = [".jpg", ".jpeg", ".png", ".mp4", ".mpeg", ".pdf"];
    const files = input.files;

    for (let i = 0; i < files.length; i++) {
        const file = files[i];
        const ext = file.name.substring(file.name.lastIndexOf('.')).toLowerCase();

        if (!validExts.includes(ext)) {
            swal.fire("檔案類型錯誤", `可接受的副檔名有：${validExts.join(", ")}`, "error");
            input.value = '';
            return false;
        }

        if (file.size > 10 * 1024 * 1024) { // 限制文件大小为10MB
            swal.fire("檔案過大", "單個檔案大小不能超過10MB", "error");
            input.value = ''; 
            return false;
        }
    }
    return true; 
}
</script>